
#include "p18f14k50.h"
#include "diskio.h"
#include "pff.h"
#include "string.h"

//prototypes
void wdtdisable (void); 
void oscsetup(void);



void main (void){


FRESULT rc;
FATFS fatfs;			/* File system object */
DIR dir;				/* Directory object */
FILINFO fno;			/* File information object */
WORD bw, br, i;
BYTE buff[32];



wdtdisable();
oscsetup();

TRISCbits.RC0 = 0;// LED to debug 

TRISAbits.RA5 = 0; // /CS set as output 


disk_initialize(); 

//while loop to check that the program exits the disk_initilize function
while(1){
LATCbits.LATC0 = 1;
} 

rc = pf_mount(&fatfs); 
rc = pf_open("WRITE.TXT");

for (;;) {
		rc = pf_write("Hello world!\r\n", 14, &bw);
		if (rc || !bw) break;}

//	printf("\nTerminate the file write process.\n");
	rc = pf_write(0, 0, &bw);
	
}



void wdtdisable (void){
WDTCONbits.SWDTEN = 0; //disable watchdog timer, might be able to use #pragma config WDTEN = OFF at the top
}

void oscsetup(void){

// Setting up internal oscialltor for 32MHz

//using primary clock so that 4xPLL can be used 
OSCCONbits.SCS0 = 0; 	
OSCCONbits.SCS1 = 0;   

OSCCONbits.IDLEN =0;    //device enters sleep mode on "sleep" instruction  
OSCCONbits.IRCF = 0x6;  // setting Internal oscillator to 8MHz (so 4xPLL can be used) 
OSCCONbits.OSTS  =0;   // Device running from High frequency internal oscillator 
OSCCONbits.IOFS = 1;   //Make High frequency oscillator stable 

OSCTUNEbits.SPLLEN = 1; //Enable PLL



}